[
define company => type {
	trait { 
		import std_delete
	}
	
	data 
		protected tablename			= 'company',
		
		public id::integer 			= 0,
		public companyName::string 	= string,
		public address1::string		= string,
		public address2::string		= string,
		public city::string			= string,
		public state::string		= 'ON',
		public country::string		= 'CA',
		public postal::string		= string,
		public status::boolean		= false

		
	// aliasing groupName... name is the shortcut :)	
	public name() => { return .companyName }
		
	/* ====================================================================================
		base onCreate method, enables faster one-step instantiate and load
	==================================================================================== */
	public onCreate(id::integer=0) => { #id > 0 ? .load(#id) }
			
	
	/* ====================================================================================
		save method
	==================================================================================== */
	public save() => { 
		if(.id == 0) => {
			inline($gv_sql,-SQL='INSERT IGNORE INTO '+.tablename+'
				SET 
					companyName 		= "'+encode_sql(.companyName)+'",
					address1 			= "'+encode_sql(.address1)+'",
					address2		 	= "'+encode_sql(.address2)+'",
					city		 		= "'+encode_sql(.city)+'",
					state		 		= "'+encode_sql(.state)+'",
					country		 		= "'+encode_sql(.country)+'",
					postal		 		= "'+encode_sql(.postal)+'",
					status 				= '+integer(.status)+';
					SELECT LAST_INSERT_ID() AS lastrow;'
			) => {
				records => { .id = integer(field('lastrow')) }
			}
		else	
			inline($gv_sql,-SQL='UPDATE '+.tablename+'
				SET 
					companyName 		= "'+encode_sql(.companyName)+'",
					address1 			= "'+encode_sql(.address1)+'",
					address2		 	= "'+encode_sql(.address2)+'",
					city		 		= "'+encode_sql(.city)+'",
					state		 		= "'+encode_sql(.state)+'",
					country		 		= "'+encode_sql(.country)+'",
					postal		 		= "'+encode_sql(.postal)+'",
					status 				= '+integer(.status)+'
				WHERE id = '+.id+'
				LIMIT 1'
				)
			/inline
		} // end insert or update if
	} // end save method

	
	/* ====================================================================================
		load method
	==================================================================================== */
	public load(id::integer=.id) => { 
		#id <= 0 ? return
		.id == 0 ? .id = #id
		inline($gv_sql,-SQL='SELECT * FROM '+.tablename+' WHERE id = '+.id+' LIMIT 1') => {
			records => {
				.companyName	= field('companyName')->asString
				.address1		= field('address1')->asString
				.address2		= field('address2')->asString
				.city			= field('city')->asString
				.state			= field('state')->asString
				.country		= field('country')->asString
				.postal			= field('postal')->asString
				.status			= boolean(field('status'))
			}
		}
	} // end load method

	
	
	
	/* ====================================================================================
		search method
	==================================================================================== */
	public search(
		term::string=string,
		-skip::integer=0,
		-max::integer=$gv_max) => { 
		local(str=string,out=array,found=0)
		// note this only searches on company name. extend the where clause to search on more!
		#term->size ? #str = ' WHERE t.companyName LIKE "%'+encode_sql(#term)+'%"'
		inline($gv_sql,-SQL='
			SELECT COUNT(*) AS f FROM '+.tablename+' AS t '+#str+'; 
			SELECT t.*
			FROM '+.tablename+' AS t 
			'+#str+' 
			ORDER BY t.companyName 
			LIMIT '+#skip+','+#max+';') => {
			resultset(1) => { #found = integer(field('f')) }
			resultset(2) => {
				records => {
					local(obj = cr_corporate)
					#obj->id				= integer(field('id'))
					#obj->companyName		= field('companyName')->asString
					#obj->address1			= field('address1')->asString
					#obj->address2			= field('address2')->asString
					#obj->city				= field('city')->asString
					#obj->state				= field('state')->asString
					#obj->country			= field('country')->asString
					#obj->postal			= field('postal')->asString
					#obj->status			= boolean(field('status'))
					#out->insert(#obj)
				}
			}
		}
		return (:#found,#out)	} // end search method
}

]